package main

import (
	"io/ioutil"
	"os"
	"path"
	"path/filepath"
)

//
func collectStructureFromFiles(directory string) (error, map[string]*requirement) {

	cleanedDirectory := path.Clean(directory)

	pageMap := make(map[string]*requirement)

	//pageMap := []requirement{}

	err := filepath.Walk(cleanedDirectory,
		func(current string, info os.FileInfo, err error) error {
			if err != nil {
				return err
			}

			cleanedPath := path.Clean(current)

			if info.IsDir() {
				return nil
			}

			ext := filepath.Ext(cleanedPath)
			if ext != ".md" {
				return nil
			}

			content, err := ioutil.ReadFile(cleanedPath)

			if err != nil {
				return err
			}

			err, p := splitYamlParts(content)

			if err != nil {
				printWarning("the file contains structural errors. check the YAML and if necessary the template.", cleanedPath, err)
				return nil
			}

			bd := []byte(cleanedDirectory)
			bp := []byte(cleanedPath)
			bs := string(bp[len(bd):len(bp)])

			p.data.File = "." + bs
			p.data.Absolute = cleanedPath
			p.data.ToDos = findTask(content)

			k := cleanedPath

			pageMap[k] = &p.data

			return nil
		})

	return err, pageMap
}
